Attribute VB_Name = "mod_enumjobsproj"
'##############################################################
'This example was written by Grant French of MC Productions UK
'Contact Info: E-Mail: grant@mcpuk.net
'##############################################################

Public Const VER_PLATFORM_WIN32_WINDOWS = 1
Public Const VER_PLATFORM_WIN32_NT = 2
Public Const Max_Number = &HFFFFFFFF
Public Const JOB_CONTROL_CANCEL = 3
Public Const PRINTER_ENUM_REMOTE = &H10
Public Const PRINTER_ENUM_LOCAL = &H2
Public Const CCHDEVICENAME = 32
Public Const CCHFORMNAME = 32

Public Type DEVMODE
        dmDeviceName As String * CCHDEVICENAME
        dmSpecVersion As Integer
        dmDriverVersion As Integer
        dmSize As Integer
        dmDriverExtra As Integer
        dmFields As Long
        dmOrientation As Integer
        dmPaperSize As Integer
        dmPaperLength As Integer
        dmPaperWidth As Integer
        dmScale As Integer
        dmCopies As Integer
        dmDefaultSource As Integer
        dmPrintQuality As Integer
        dmColor As Integer
        dmDuplex As Integer
        dmYResolution As Integer
        dmTTOption As Integer
        dmCollate As Integer
        dmFormName As String * CCHFORMNAME
        dmUnusedPadding As Integer
        dmBitsPerPel As Long
        dmPelsWidth As Long
        dmPelsHeight As Long
        dmDisplayFlags As Long
        dmDisplayFrequency As Long
End Type

Public Type PRINTER_INFO_1
        flags As Long
        pDescription As String
        pName As String
        pComment As String
End Type

Public Type OSVERSIONINFO
  OSVSize         As Long
  dwVerMajor      As Long
  dwVerMinor      As Long
  dwBuildNumber   As Long
  PlatformID      As Long
  szCSDVersion    As String * 128
End Type

Type SYSTEMTIME
  wYear As Integer
  wMonth As Integer
  wDayOfWeek As Integer
  wDay As Integer
  wHour As Integer
  wMinute As Integer
  wSecond As Integer
  wMilliseconds As Integer
End Type

Public Type PRINTER_DEFAULTS
        pDatatype As String
        pDevMode As DEVMODE
        DesiredAccess As Long
End Type

Public Type JOB_INFO_1
        JobID As Long
        pPrinterName As String
        pMachineName As String
        pUserName As String
        pDocument As String
        pDatatype As String
        pStatus As String
        Status As Long
        Priority As Long
        Position As Long
        TotalPages As Long
        PagesPrinted As Long
        Submitted As SYSTEMTIME
End Type

Public Declare Function SetJob Lib "winspool.drv" Alias "SetJobA" (ByVal hPrinter As Long, ByVal JobID As Long, ByVal Level As Long, pJob As Byte, ByVal Command As Long) As Long
Public Declare Function OpenPrinter Lib "winspool.drv" Alias "OpenPrinterA" (ByVal pPrinterName As String, phPrinter As Long, pDefault As PRINTER_DEFAULTS) As Long
Public Declare Function ClosePrinter Lib "winspool.drv" (ByVal hPrinter As Long) As Long
Public Declare Sub CopyMemory Lib "kernel32.dll" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)
Public Declare Function lstrcpy Lib "kernel32.dll" Alias "lstrcpyA" (ByVal lpString1 As Any, ByVal lpString2 As Any) As Long
Public Declare Function EnumJobs Lib "winspool.drv" Alias "EnumJobsA" (ByVal hPrinter As Long, ByVal FirstJob As Long, ByVal NoJobs As Long, ByVal Level As Long, pJob As Long, ByVal cbBuf As Long, pcbNeeded As Long, pcReturned As Long) As Long
Public Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long
Public Declare Function EnumPrinters Lib "winspool.drv" Alias "EnumPrintersA" (ByVal flags As Long, ByVal name As String, ByVal Level As Long, pPrinterEnum As Long, ByVal cdBuf As Long, pcbNeeded As Long, pcReturned As Long) As Long
Public Declare Function lstrlen Lib "kernel32.dll" Alias "lstrlenA" (ByVal lpString As Long) As Long

Public Sub GetPrinters(lstCtrl As ListBox, RemotePrinters As Boolean)
'This sub retrieves a list of printers available on the system

'Declare all of the variables required for this procedure
Dim PRINTERENUM As Long
Dim longbuffer() As Long
Dim printinfo() As PRINTER_INFO_1
Dim numbytes As Long
Dim numneeded As Long
Dim numprinters As Long
Dim c As Integer, retval As Long

'Set the initial values of the variables and the number of items in the array(s)
numbytes = 3076
ReDim longbuffer(0 To numbytes / 4) As Long

'Check if the caller wants remote or local printers
If RemotePrinters = True Then
      PRINTERENUM = PRINTER_ENUM_REMOTE
Else
      PRINTERENUM = PRINTER_ENUM_LOCAL
End If

'Call the EnumPrinters to find the number of bytes required by the function to return the printers
retval = EnumPrinters(PRINTERENUM, "", 1, longbuffer(0), numbytes, numneeded, numprinters)

If retval = 0 Then
      'If there was an error (not enough memort) then call the API function again
      'allowing it the number of bytes required to return the printers
      numbytes = numneeded
      ReDim longbuffer(0 To numbytes / 4) As Long
      
      retval = EnumPrinters(PRINTERENUM, "", 1, longbuffer(0), numbytes, numneeded, numprinters)
      
      'If there was an error this time then something is wrong, time to leave
      If retval = 0 Then Exit Sub

End If

'Redefine the printinfo array to allow room for all of the printers retrieved
ReDim printinfo(0 To numprinters - 1) As PRINTER_INFO_1

'Loop through all of the printers retrieved
For c = 0 To numprinters - 1

      'Get the information out of its original form and into our printinfo array as seperated strings
      printinfo(c).flags = longbuffer(4 * c)
      printinfo(c).pDescription = Space(lstrlen(longbuffer(4 * c + 1)))
      
      retval = lstrcpy(printinfo(c).pDescription, longbuffer(4 * c + 1))
      printinfo(c).pName = Space(lstrlen(longbuffer(4 * c + 2)))
      
      retval = lstrcpy(printinfo(c).pName, longbuffer(4 * c + 2))
      printinfo(c).pComment = Space(lstrlen(longbuffer(4 * c + 3)))
      
      retval = lstrcpy(printinfo(c).pComment, longbuffer(4 * c + 3))
      
      'Add the printer to the listbox specified by the caller
      lstCtrl.AddItem printinfo(c).pName
      
Next c

End Sub


Public Sub GetPrintJobs(PrinterName As String, lstCtrl As ListBox)
'This sub retrieves a list of print jobs available on the specified printer

'Declare all of the variables required for this procedure
Dim PrinterDefaults As PRINTER_DEFAULTS
Dim PrinterHandle As Long
Dim MemoryNeeded As Long
Dim MemoryBuffer As Long
Dim NumberOfJobs As Long
Dim Jobs() As Long
Dim JobInfo As JOB_INFO_1

    'Open a handle to the printer specified by the caller
    a = OpenPrinter(PrinterName, PrinterHandle, PrinterDefaults)
    
    'Call the EnumJobs to find the number of bytes required by the function to return the jobs
    b = EnumJobs(PrinterHandle, 0, Max_Number, 1, 0, MemoryBuffer, MemoryNeeded, NumberOfJobs)
    MemoryBuffer = MemoryNeeded
    
    'If the function does not require any memory,
    'then there are no jobs to be returned so exit the procedure
    If MemoryNeeded = 0 Then Exit Sub
    
    'Redefine the Jobs array to make room for the jobs that will be returned
    ReDim Jobs(0 To (MemoryNeeded / 4 - 1))
    
    'Get all of the print jobs for the specified printer
    c = EnumJobs(PrinterHandle, 0, Max_Number, 1, Jobs(0), MemoryBuffer, MemoryNeeded, NumberOfJobs)
    
    'Workout 1/4 of the length of the returned data for seperating out the items of the Jobs
    lendivfour = Len(JobInfo) / 4
    
    'Loop though all of the jobs and process them all into their components
    For c = 0 To NumberOfJobs - 1
            
              JobInfo.JobID = Jobs(lendivfour * c)
              JobInfo.pUserName = Space(lstrlen(Jobs(lendivfour * c + 3)))
              
              retval = lstrcpy(JobInfo.pUserName, Jobs(lendivfour * c + 3))
              JobInfo.pDocument = Space(lstrlen(Jobs(lendivfour * c + 4)))
              
              retval = lstrcpy(JobInfo.pDocument, Jobs(lendivfour * c + 4))
              JobInfo.pMachineName = Space(lstrlen(Jobs(lendivfour * c + 2)))
              
              retval = lstrcpy(JobInfo.pMachineName, Jobs(lendivfour * c + 2))
              JobInfo.TotalPages = Jobs(lendivfour * c + 10)
              
              CopyMemory JobInfo.Submitted, Jobs(lendivfour * c + 12), Len(JobInfo.Submitted)
              
              'If the job has no pages then skip it because it hasn't finished spooling yet.
              If JobInfo.TotalPages = 0 Then
                        a = ClosePrinter(PrinterHandle)
                        GoTo DontOutputJob
              End If
              
              'Add the job to the listbox specified, use semi-colon seperation of data.
              lstCtrl.AddItem JobInfo.JobID & ";" & PrinterName & ";" & JobInfo.pUserName & ";" & JobInfo.pMachineName & ";" & JobInfo.pDocument & ";" & JobInfo.TotalPages & ";" & Format$(JobInfo.Submitted.wHour, "00") & ":" & Format$(JobInfo.Submitted.wMinute, "00") & ":" & Format$(JobInfo.Submitted.wSecond, "00") & "  " & Format$(JobInfo.Submitted.wDay, "00") & "/" & Format$(JobInfo.Submitted.wMonth, "00") & "/" & Format$(JobInfo.Submitted.wYear, "0000")
             
DontOutputJob:
             
             'Don't hog the system to yourself
             DoEvents
             
    Next c
    
'Close the handle to the printer
a = ClosePrinter(PrinterHandle)

End Sub

Public Function CancelPrintJob(PrinterName As String, JobID As Long)
      'Cancel the specified print job on the specified printer

      'Declare all of the variables required for this procedure
      Dim PrinterDefaults As PRINTER_DEFAULTS
      Dim PrinterHandle As Long
      Dim MemoryNeeded As Long
      Dim MemoryBuffer As Long
      Dim NumberOfJobs As Long
      Dim Jobs() As Long
      Dim JobInfo As JOB_INFO_1

     'Open a handle to the printer specified by the caller
      a = OpenPrinter(PrinterName, PrinterHandle, PrinterDefaults)
      
      a = SetJob(PrinterHandle, JobID, 0, 0, JOB_CONTROL_CANCEL)
      
      'Close the handle to the printer
      a = ClosePrinter(PrinterHandle)
      
End Function


